<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 4</a>

    <script>


        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null; 
            }
        }
            
        const altura = (root) => {
            if (root === null) {
                return 0;
            }
            return Math.max(altura(root.left), altura(root.right)) + 1;
        }

        const balanceado = (root) => {
            if (root === null) {
                return true;
            }

            let lh = altura(root.left),
                rh = altura(root.right);

            if ((Math.abs(lh - rh)) <= 1 && 
                balanceado(root.left) === true &&
                balanceado(root.right) === true) {
                    return true;
            }

            return false;
        }

        let root;
        root = new Node(8);
        root.left = new Node(5);
        root.right = new Node(1);
        root.left.left = new Node(3);
        root.left.right = new Node(9);
        //root.left.left.left = new Node(4);

        if (balanceado(root)) {
            console.log("El Arbol esta Balanceado");
        } else {
            console.log("El Arbol NO esta Balanceado");
        }
        
    </script>
    
</body>
</html>